# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from abb_rapid_sm_addin_msgs/EGMActivateSettings.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import abb_rapid_msgs.msg

class EGMActivateSettings(genpy.Message):
  _md5sum = "edc93be8ce076e9147c54b4dc80e7974"
  _type = "abb_rapid_sm_addin_msgs/EGMActivateSettings"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the custom RAPID
#   data type "EGMActivateSettings" from the RobotWare "StateMachine Add-In".
#
# Note:
#   "EGMActivateSettings" are for example used with the RAPID EGM instructions
#   "EGMActJoint" and "EGMActPose".
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# Tool to use for EGM motions.
abb_rapid_msgs/ToolData tool

# Work object to use for EGM motions.
abb_rapid_msgs/WObjData wobj

# Correction frame to use for EGM motions (only used in EGM pose mode).
abb_rapid_msgs/Pose correction_frame

# Sensor frame to use for EGM motions (only used in EGM pose mode).
abb_rapid_msgs/Pose sensor_frame

# Condition threshold value [deg or mm] for when an EGM motion's convergence
# criteria is considered to be fulfilled.
float32 cond_min_max

# Low pass filter bandwidth [Hz] for the EGM controller.
float32 lp_filter

# Sample rate [ms] for the EGM communication.
uint8 sample_rate

# Maximum admitted joint speed [deg/s].
float32 max_speed_deviation

================================================================================
MSG: abb_rapid_msgs/ToolData
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "tooldata" (tool data).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# Defines whether or not the robot is holding the tool:
# - TRUE: The robot is holding the tool.
# - FALSE: The robot is not holding the tool, that is, a stationary tool.
bool robhold

# The tool coordinate system, that is:
# - The position of the TCP (x, y and z) in mm,
#   expressed in the wrist coordinate system (tool0).
# - The orientation of the tool coordinate system,
#   expressed in the wrist coordinate system.
Pose tframe

# The load of the tool (if robot held tool).
# The load of the gripper holding the work object (if stationary tool).
LoadData tload

================================================================================
MSG: abb_rapid_msgs/Pose
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "pose" (coordinate transformations).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# The displacement in position (x, y, and z) of the coordinate system.
Pos trans

# The rotation of the coordinate system.
Orient rot

================================================================================
MSG: abb_rapid_msgs/Pos
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "pos" (positions (only X, Y and Z)).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# The x-, y- and z-value of the position.
float32 x
float32 y
float32 z

================================================================================
MSG: abb_rapid_msgs/Orient
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "orient" (orientation).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# Quaternion 1-4.
float32 q1
float32 q2
float32 q3
float32 q4

================================================================================
MSG: abb_rapid_msgs/LoadData
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "loaddata" (load data).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# The mass (weight) of the load in kg.
float32 mass

# The center of gravity of the payload, expressed in mm,
# in the tool coordinate system if the robot is holding the tool.
#
# If a stationary tool is used then the center of gravity for the payload
# held by the gripper is expressed in the object frame of the work object
# coordinate system moved by the robot.
Pos cog

# The orientation of the axes of moment.
#
# These are the principal axes of the payload
# moment of inertia with origin in cog.
#
# If the robot is holding the tool, the axes of moment
# are expressed in the tool coordinate system.
Orient aom

# The moment of inertia of the load around the x-, y- and z-axis,
# expressed in kgm^2.
float32 ix
float32 iy
float32 iz

================================================================================
MSG: abb_rapid_msgs/WObjData
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "wobjdata" (work object data).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# Defines whether or not the robot in the actual
# program task is holding the work object:
# - TRUE: The robot is holding the work object,
#         i.e. using a stationary tool.
# - FALSE: The robot is not holding the work object,
#          i.e. the robot is holding the tool.
bool robhold

# Defines whether or not a fixed user coordinate system is used:
# - TRUE: Fixed user coordinate system.
# - FALSE: Movable user coordinate system,
#          i.e. coordinated external axes are used.
#          Also to be used in a MultiMove system in
#          semicoordinated or synchronized coordinated mode.
bool ufprog

# The mechanical unit with which the robot movements are coordinated.
#
# Only specified in the case of movable user
# coordinate systems (ufprog is FALSE).
string ufmec

# The user coordinate system, i.e. the position
# of the current work surface or fixture.
Pose uframe

# The object coordinate system, i.e. the position
# of the current work object.
Pose oframe
"""
  __slots__ = ['tool','wobj','correction_frame','sensor_frame','cond_min_max','lp_filter','sample_rate','max_speed_deviation']
  _slot_types = ['abb_rapid_msgs/ToolData','abb_rapid_msgs/WObjData','abb_rapid_msgs/Pose','abb_rapid_msgs/Pose','float32','float32','uint8','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       tool,wobj,correction_frame,sensor_frame,cond_min_max,lp_filter,sample_rate,max_speed_deviation

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EGMActivateSettings, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.tool is None:
        self.tool = abb_rapid_msgs.msg.ToolData()
      if self.wobj is None:
        self.wobj = abb_rapid_msgs.msg.WObjData()
      if self.correction_frame is None:
        self.correction_frame = abb_rapid_msgs.msg.Pose()
      if self.sensor_frame is None:
        self.sensor_frame = abb_rapid_msgs.msg.Pose()
      if self.cond_min_max is None:
        self.cond_min_max = 0.
      if self.lp_filter is None:
        self.lp_filter = 0.
      if self.sample_rate is None:
        self.sample_rate = 0
      if self.max_speed_deviation is None:
        self.max_speed_deviation = 0.
    else:
      self.tool = abb_rapid_msgs.msg.ToolData()
      self.wobj = abb_rapid_msgs.msg.WObjData()
      self.correction_frame = abb_rapid_msgs.msg.Pose()
      self.sensor_frame = abb_rapid_msgs.msg.Pose()
      self.cond_min_max = 0.
      self.lp_filter = 0.
      self.sample_rate = 0
      self.max_speed_deviation = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B18f2B().pack(_x.tool.robhold, _x.tool.tframe.trans.x, _x.tool.tframe.trans.y, _x.tool.tframe.trans.z, _x.tool.tframe.rot.q1, _x.tool.tframe.rot.q2, _x.tool.tframe.rot.q3, _x.tool.tframe.rot.q4, _x.tool.tload.mass, _x.tool.tload.cog.x, _x.tool.tload.cog.y, _x.tool.tload.cog.z, _x.tool.tload.aom.q1, _x.tool.tload.aom.q2, _x.tool.tload.aom.q3, _x.tool.tload.aom.q4, _x.tool.tload.ix, _x.tool.tload.iy, _x.tool.tload.iz, _x.wobj.robhold, _x.wobj.ufprog))
      _x = self.wobj.ufmec
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_30fBf().pack(_x.wobj.uframe.trans.x, _x.wobj.uframe.trans.y, _x.wobj.uframe.trans.z, _x.wobj.uframe.rot.q1, _x.wobj.uframe.rot.q2, _x.wobj.uframe.rot.q3, _x.wobj.uframe.rot.q4, _x.wobj.oframe.trans.x, _x.wobj.oframe.trans.y, _x.wobj.oframe.trans.z, _x.wobj.oframe.rot.q1, _x.wobj.oframe.rot.q2, _x.wobj.oframe.rot.q3, _x.wobj.oframe.rot.q4, _x.correction_frame.trans.x, _x.correction_frame.trans.y, _x.correction_frame.trans.z, _x.correction_frame.rot.q1, _x.correction_frame.rot.q2, _x.correction_frame.rot.q3, _x.correction_frame.rot.q4, _x.sensor_frame.trans.x, _x.sensor_frame.trans.y, _x.sensor_frame.trans.z, _x.sensor_frame.rot.q1, _x.sensor_frame.rot.q2, _x.sensor_frame.rot.q3, _x.sensor_frame.rot.q4, _x.cond_min_max, _x.lp_filter, _x.sample_rate, _x.max_speed_deviation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.tool is None:
        self.tool = abb_rapid_msgs.msg.ToolData()
      if self.wobj is None:
        self.wobj = abb_rapid_msgs.msg.WObjData()
      if self.correction_frame is None:
        self.correction_frame = abb_rapid_msgs.msg.Pose()
      if self.sensor_frame is None:
        self.sensor_frame = abb_rapid_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 75
      (_x.tool.robhold, _x.tool.tframe.trans.x, _x.tool.tframe.trans.y, _x.tool.tframe.trans.z, _x.tool.tframe.rot.q1, _x.tool.tframe.rot.q2, _x.tool.tframe.rot.q3, _x.tool.tframe.rot.q4, _x.tool.tload.mass, _x.tool.tload.cog.x, _x.tool.tload.cog.y, _x.tool.tload.cog.z, _x.tool.tload.aom.q1, _x.tool.tload.aom.q2, _x.tool.tload.aom.q3, _x.tool.tload.aom.q4, _x.tool.tload.ix, _x.tool.tload.iy, _x.tool.tload.iz, _x.wobj.robhold, _x.wobj.ufprog,) = _get_struct_B18f2B().unpack(str[start:end])
      self.tool.robhold = bool(self.tool.robhold)
      self.wobj.robhold = bool(self.wobj.robhold)
      self.wobj.ufprog = bool(self.wobj.ufprog)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.wobj.ufmec = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.wobj.ufmec = str[start:end]
      _x = self
      start = end
      end += 125
      (_x.wobj.uframe.trans.x, _x.wobj.uframe.trans.y, _x.wobj.uframe.trans.z, _x.wobj.uframe.rot.q1, _x.wobj.uframe.rot.q2, _x.wobj.uframe.rot.q3, _x.wobj.uframe.rot.q4, _x.wobj.oframe.trans.x, _x.wobj.oframe.trans.y, _x.wobj.oframe.trans.z, _x.wobj.oframe.rot.q1, _x.wobj.oframe.rot.q2, _x.wobj.oframe.rot.q3, _x.wobj.oframe.rot.q4, _x.correction_frame.trans.x, _x.correction_frame.trans.y, _x.correction_frame.trans.z, _x.correction_frame.rot.q1, _x.correction_frame.rot.q2, _x.correction_frame.rot.q3, _x.correction_frame.rot.q4, _x.sensor_frame.trans.x, _x.sensor_frame.trans.y, _x.sensor_frame.trans.z, _x.sensor_frame.rot.q1, _x.sensor_frame.rot.q2, _x.sensor_frame.rot.q3, _x.sensor_frame.rot.q4, _x.cond_min_max, _x.lp_filter, _x.sample_rate, _x.max_speed_deviation,) = _get_struct_30fBf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B18f2B().pack(_x.tool.robhold, _x.tool.tframe.trans.x, _x.tool.tframe.trans.y, _x.tool.tframe.trans.z, _x.tool.tframe.rot.q1, _x.tool.tframe.rot.q2, _x.tool.tframe.rot.q3, _x.tool.tframe.rot.q4, _x.tool.tload.mass, _x.tool.tload.cog.x, _x.tool.tload.cog.y, _x.tool.tload.cog.z, _x.tool.tload.aom.q1, _x.tool.tload.aom.q2, _x.tool.tload.aom.q3, _x.tool.tload.aom.q4, _x.tool.tload.ix, _x.tool.tload.iy, _x.tool.tload.iz, _x.wobj.robhold, _x.wobj.ufprog))
      _x = self.wobj.ufmec
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_30fBf().pack(_x.wobj.uframe.trans.x, _x.wobj.uframe.trans.y, _x.wobj.uframe.trans.z, _x.wobj.uframe.rot.q1, _x.wobj.uframe.rot.q2, _x.wobj.uframe.rot.q3, _x.wobj.uframe.rot.q4, _x.wobj.oframe.trans.x, _x.wobj.oframe.trans.y, _x.wobj.oframe.trans.z, _x.wobj.oframe.rot.q1, _x.wobj.oframe.rot.q2, _x.wobj.oframe.rot.q3, _x.wobj.oframe.rot.q4, _x.correction_frame.trans.x, _x.correction_frame.trans.y, _x.correction_frame.trans.z, _x.correction_frame.rot.q1, _x.correction_frame.rot.q2, _x.correction_frame.rot.q3, _x.correction_frame.rot.q4, _x.sensor_frame.trans.x, _x.sensor_frame.trans.y, _x.sensor_frame.trans.z, _x.sensor_frame.rot.q1, _x.sensor_frame.rot.q2, _x.sensor_frame.rot.q3, _x.sensor_frame.rot.q4, _x.cond_min_max, _x.lp_filter, _x.sample_rate, _x.max_speed_deviation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.tool is None:
        self.tool = abb_rapid_msgs.msg.ToolData()
      if self.wobj is None:
        self.wobj = abb_rapid_msgs.msg.WObjData()
      if self.correction_frame is None:
        self.correction_frame = abb_rapid_msgs.msg.Pose()
      if self.sensor_frame is None:
        self.sensor_frame = abb_rapid_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 75
      (_x.tool.robhold, _x.tool.tframe.trans.x, _x.tool.tframe.trans.y, _x.tool.tframe.trans.z, _x.tool.tframe.rot.q1, _x.tool.tframe.rot.q2, _x.tool.tframe.rot.q3, _x.tool.tframe.rot.q4, _x.tool.tload.mass, _x.tool.tload.cog.x, _x.tool.tload.cog.y, _x.tool.tload.cog.z, _x.tool.tload.aom.q1, _x.tool.tload.aom.q2, _x.tool.tload.aom.q3, _x.tool.tload.aom.q4, _x.tool.tload.ix, _x.tool.tload.iy, _x.tool.tload.iz, _x.wobj.robhold, _x.wobj.ufprog,) = _get_struct_B18f2B().unpack(str[start:end])
      self.tool.robhold = bool(self.tool.robhold)
      self.wobj.robhold = bool(self.wobj.robhold)
      self.wobj.ufprog = bool(self.wobj.ufprog)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.wobj.ufmec = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.wobj.ufmec = str[start:end]
      _x = self
      start = end
      end += 125
      (_x.wobj.uframe.trans.x, _x.wobj.uframe.trans.y, _x.wobj.uframe.trans.z, _x.wobj.uframe.rot.q1, _x.wobj.uframe.rot.q2, _x.wobj.uframe.rot.q3, _x.wobj.uframe.rot.q4, _x.wobj.oframe.trans.x, _x.wobj.oframe.trans.y, _x.wobj.oframe.trans.z, _x.wobj.oframe.rot.q1, _x.wobj.oframe.rot.q2, _x.wobj.oframe.rot.q3, _x.wobj.oframe.rot.q4, _x.correction_frame.trans.x, _x.correction_frame.trans.y, _x.correction_frame.trans.z, _x.correction_frame.rot.q1, _x.correction_frame.rot.q2, _x.correction_frame.rot.q3, _x.correction_frame.rot.q4, _x.sensor_frame.trans.x, _x.sensor_frame.trans.y, _x.sensor_frame.trans.z, _x.sensor_frame.rot.q1, _x.sensor_frame.rot.q2, _x.sensor_frame.rot.q3, _x.sensor_frame.rot.q4, _x.cond_min_max, _x.lp_filter, _x.sample_rate, _x.max_speed_deviation,) = _get_struct_30fBf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_30fBf = None
def _get_struct_30fBf():
    global _struct_30fBf
    if _struct_30fBf is None:
        _struct_30fBf = struct.Struct("<30fBf")
    return _struct_30fBf
_struct_B18f2B = None
def _get_struct_B18f2B():
    global _struct_B18f2B
    if _struct_B18f2B is None:
        _struct_B18f2B = struct.Struct("<B18f2B")
    return _struct_B18f2B
